HitsMode5 = LibStub("AceAddon-3.0"):NewAddon("HitsMode5", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
HitsMode5.MINOR_VERSION = tonumber(("$Revision: 18 $"):match("%d+"))
local L = LibStub("AceLocale-3.0"):GetLocale("HitsMode5")
local HitsMode5 = HitsMode5
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("HitsMode5", {label = "HitsMode5", type = "data source", icon = "Interface\\Icons\\Ability_CriticalStrike", text = ""})




--[[
      LOCALS -------------------------------------------------------------------------------------------------------------------
  ]]

local isEnabled = false
local NUM_HELPARTICLES = 1
local filters = {}

local specialEvents = {
	"PLAYER_REGEN_DISABLED",
	"PLAYER_REGEN_ENABLED",
	"CHAT_MSG_COMBAT_XP_GAIN",
	"CHAT_MSG_LOOT",
	"CHAT_MSG_COMBAT_FACTION_CHANGE",
	"CHAT_MSG_COMBAT_HONOR_GAIN",
	"CHAT_MSG_MONEY",
	"CHAT_MSG_SKILL",
}

local DISPLAYMODE_STANDARD = 1
local DISPLAYMODE_STANDARD_NUMBERS_FIRST = 2
local DISPLAYMODE_NUMBERS_ONLY = 3

local FLAG_CRITS = 1
local FLAG_HEALS = 2
local FLAG_PET_DAMAGE = 3
local FLAG_ENERGIZES = 4
local FLAG_EXP = 5
local FLAG_HONOR = 6
local FLAG_REP = 7



--[[
      UPVALUES -----------------------------------------------------------------------------------------------------------------
  ]]
  
local _G = getfenv(0)
local bit_bor = _G.bit.bor
local bit_band = _G.bit.band
local tinsert = _G.tinsert
local tremove = _G.tremove
local math_floor = _G.math.floor
local format = _G.format
local gsub = _G.gsub
local strsub = _G.strsub
local strreplace = _G.strreplace
local strsplit = _G.strsplit

local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local COMBATLOG_OBJECT_AFFILIATION_PARTY = COMBATLOG_OBJECT_AFFILIATION_PARTY
local COMBATLOG_OBJECT_AFFILIATION_RAID = COMBATLOG_OBJECT_AFFILIATION_RAID
local COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = COMBATLOG_OBJECT_AFFILIATION_OUTSIDER
local COMBATLOG_OBJECT_AFFILIATION_MASK = COMBATLOG_OBJECT_AFFILIATION_MASK
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY
local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE
local COMBATLOG_OBJECT_REACTION_MASK = COMBATLOG_OBJECT_REACTION_MASK
local COMBATLOG_OBJECT_CONTROL_PLAYER = COMBATLOG_OBJECT_CONTROL_PLAYER
local COMBATLOG_OBJECT_CONTROL_NPC = COMBATLOG_OBJECT_CONTROL_NPC
local COMBATLOG_OBJECT_CONTROL_MASK = COMBATLOG_OBJECT_CONTROL_MASK
local COMBATLOG_OBJECT_TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
local COMBATLOG_OBJECT_TYPE_NPC = COMBATLOG_OBJECT_TYPE_NPC
local COMBATLOG_OBJECT_TYPE_PET = COMBATLOG_OBJECT_TYPE_PET
local COMBATLOG_OBJECT_TYPE_GUARDIAN = COMBATLOG_OBJECT_TYPE_GUARDIAN
local COMBATLOG_OBJECT_TYPE_OBJECT = COMBATLOG_OBJECT_TYPE_OBJECT
local COMBATLOG_OBJECT_TYPE_MASK = COMBATLOG_OBJECT_TYPE_MASK
local COMBATLOG_OBJECT_TARGET = COMBATLOG_OBJECT_TARGET
local COMBATLOG_OBJECT_FOCUS = COMBATLOG_OBJECT_FOCUS
local COMBATLOG_OBJECT_MAINTANK = COMBATLOG_OBJECT_MAINTANK
local COMBATLOG_OBJECT_MAINASSIST = COMBATLOG_OBJECT_MAINASSIST
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8
local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE
local COMBATLOG_OBJECT_SPECIAL_MASK = COMBATLOG_OBJECT_SPECIAL_MASK
local COMBATLOG_FILTER_ME = COMBATLOG_FILTER_ME
local COMBATLOG_FILTER_MINE = COMBATLOG_FILTER_MINE
local COMBATLOG_FILTER_MY_PET = COMBATLOG_FILTER_MY_PET
local COMBATLOG_FILTER_FRIENDLY_UNITS = COMBATLOG_FILTER_FRIENDLY_UNITS
local COMBATLOG_FILTER_HOSTILE_UNITS = COMBATLOG_FILTER_HOSTILE_UNITS
local COMBATLOG_FILTER_HOSTILE_PLAYERS = COMBATLOG_FILTER_HOSTILE_PLAYERS
local COMBATLOG_FILTER_NEUTRAL_UNITS = COMBATLOG_FILTER_NEUTRAL_UNITS
local COMBATLOG_FILTER_UNKNOWN_UNITS = COMBATLOG_FILTER_UNKNOWN_UNITS
local COMBATLOG_FILTER_EVERYTHING = COMBATLOG_FILTER_EVERYTHING
local COMBATLOG = COMBATLOG
local AURA_TYPE_BUFF = AURA_TYPE_BUFF
local AURA_TYPE_DEBUFF = AURA_TYPE_DEBUFF
local SPELL_POWER_MANA = SPELL_POWER_MANA
local SPELL_POWER_RAGE = SPELL_POWER_RAGE
local SPELL_POWER_FOCUS = SPELL_POWER_FOCUS
local SPELL_POWER_ENERGY = SPELL_POWER_ENERGY
local SPELL_POWER_HAPPINESS = SPELL_POWER_HAPPINESS
local SPELL_POWER_RUNES = SPELL_POWER_RUNES
local SPELL_POWER_RUNIC_POWER = SPELL_POWER_RUNIC_POWER
local SCHOOL_MASK_NONE = SCHOOL_MASK_NONE
local SCHOOL_MASK_PHYSICAL = SCHOOL_MASK_PHYSICAL
local SCHOOL_MASK_HOLY = SCHOOL_MASK_HOLY
local SCHOOL_MASK_FIRE = SCHOOL_MASK_FIRE
local SCHOOL_MASK_NATURE = SCHOOL_MASK_NATURE
local SCHOOL_MASK_FROST = SCHOOL_MASK_FROST
local SCHOOL_MASK_SHADOW = SCHOOL_MASK_SHADOW
local SCHOOL_MASK_ARCANE = SCHOOL_MASK_ARCANE
local COMBATLOG_LIMIT_PER_FRAME = COMBATLOG_LIMIT_PER_FRAME
local COMBATLOG_HIGHLIGHT_MULTIPLIER = COMBATLOG_HIGHLIGHT_MULTIPLIER
local COMBATLOG_DEFAULT_COLORS = COMBATLOG_DEFAULT_COLORS
local COMBATLOG_DEFAULT_SETTINGS = COMBATLOG_DEFAULT_SETTINGS
local COMBATLOG_ICON_RAIDTARGET1 = COMBATLOG_ICON_RAIDTARGET1
local COMBATLOG_ICON_RAIDTARGET2 = COMBATLOG_ICON_RAIDTARGET2
local COMBATLOG_ICON_RAIDTARGET3 = COMBATLOG_ICON_RAIDTARGET3
local COMBATLOG_ICON_RAIDTARGET4 = COMBATLOG_ICON_RAIDTARGET4
local COMBATLOG_ICON_RAIDTARGET5 = COMBATLOG_ICON_RAIDTARGET5
local COMBATLOG_ICON_RAIDTARGET6 = COMBATLOG_ICON_RAIDTARGET6
local COMBATLOG_ICON_RAIDTARGET7 = COMBATLOG_ICON_RAIDTARGET7
local COMBATLOG_ICON_RAIDTARGET8 = COMBATLOG_ICON_RAIDTARGET8
local COMBATLOG_EVENT_LIST = COMBATLOG_EVENT_LIST



--[[
      UTILITIES ----------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:tcopy(to, from)
 for k, v in pairs(from) do
  if(type(v) == "table") then
   to[k] = {}
   HitsMode5:tcopy(to[k], v)
  else
   to[k] = v
  end
 end
end

function boolToString(b)
	if b == true then return "true" end
	if b == false then return "false" end
	if b == nil then return "nil" end
end



--[[
      HELP SYSTEM --------------------------------------------------------------------------------------------------------------
  ]]

do
	local i
	for i = 1, NUM_HELPARTICLES do
		HelpLib.AddQuestion({
			q = L["help_question_"..i],
			a = L["help_answer_"..i],
			cat = "HitsMode5",
		});
	end
end

function HitsMode5:CheckHelpLoaded()
 if (KBSetup_IsLoaded()) then
  KnowledgeBaseFrameEditBox:SetText("")
  UIDropDownMenu_SetSelectedName(KnowledgeBaseFrameCategoryDropDown, "HitsMode5")
  KnowledgeBaseFrame_Search(1)
 else
		self:ScheduleTimer("CheckHelpLoaded", 0.2)
 end
end



--[[
      INITIALIZATION -----------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:OnInitialize()
	-- Register database and options
 self.db = LibStub("AceDB-3.0"):New("HitsMode5DB", self.defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("HitsMode5", self.options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HitsMode5", "HitsMode5")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("HitsMode5-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HitsMode5-Profiles", "Profiles", "HitsMode5")
	
	-- Register for slash commands
	self:RegisterChatCommand("hitsmode", "ChatCommand")
	self:RegisterChatCommand("hm", "ChatCommand")
	
 -- Initialize settings
	self:ReloadSettings()
end


function HitsMode5:OnEnable()
	-- Make sure the Blizzard Combat Log is loaded
	local result = LoadAddOn("Blizzard_CombatLog")
	if result ~= 1 then
		self:Print(format(L["Unable to load Blizzard Combat Log. HitsMode5 cannot be enabled. (Reason: %s)"], _G["ADDON_"..result]))
		self:Disable()
		return
	end
	
	-- Register for events
 for k, v in pairs(specialEvents) do
  self:RegisterEvent(v, "OnSpecialEvent");
 end
 self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent")
 
 -- Turn us on
	isEnabled = true

--[===[@debug@
	self:Print(L["Loaded"])
--@end-debug@]===]
end


function HitsMode5:OnDisable()
	-- Unregister all events
	self:UnregisterAllEvents()

	-- Turn us off
	isEnabled = false
end


function HitsMode5:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(HitsMode5, "hm", "HitsMode5", input)
	end
end



--[[
      FILTERS ------------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:GetFilters()
	return filters
end


function HitsMode5:CreateFilter(name, db)
	if not db then
		db = {}
		self:tcopy(db, self.filterDefaults)
		table.insert(self.db.profile.filters, db)
	end

	local filter = HitsMode5.Filter:new()
	filter.db = db
	filter.db.name = name
	
	table.insert(filters, filter)
	
	filter:AddOptions()
	self:ApplySettings()
end


function HitsMode5:DeleteFilter(name)
	for k, v in ipairs(filters) do
		if v.db.name == name then
			v:destroy()
			wipe(table.remove(filters, k))
		end
	end
	for k, v in ipairs(self.db.profile.filters) do
		if v.name == name then
			table.remove(self.db.profile.filters, k)
		end
	end
	HitsMode5.options.args.filters.args[name] = nil
end



--[[
      SETTINGS APPLICATION -----------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:ReloadSettings()
	for k, v in ipairs(filters) do
		v:destroy()
	end
	filters = {}

	for k, v in ipairs(self.db.profile.filters) do
		self:CreateFilter(v.name, v)
	end

	self:ApplySettings()
end


function HitsMode5:ApplyFilters()
end


function HitsMode5:ApplySettings()
	self:ApplyFilters()
end


--[[
      EVENTS -------------------------------------------------------------------------------------------------------------------
  ]]

function HitsMode5:OnSpecialEvent(event, ...)
 if (isEnabled) then
		--
 end
end


function HitsMode5:OnCombatEvent(event, ...)
 if (isEnabled) then
		--
 end
end

